package com.dsic.gj_erp.pc.dto;

import com.dsic.gj_erp.pc.Constant;
import com.dsic.gj_erp.pc.service.设备接口;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
public abstract class 设备 implements 设备接口 {
    protected String 设备编号;
    protected String 设备名称;
    protected double 白班设备产能;
    protected double 二班设备产能;
    protected double 产能;
    protected volatile double 占用=0.0;
    protected List<String> 资源占用图纸表;

    @Override
    public void 修正工作量(double 白班时长, double 二班时长) {
        this.产能=0;
        if (白班时长>0){
            this.产能+=白班时长*白班设备产能/7.0;
        }
        if (二班时长>0){
            this.产能+=二班时长*二班设备产能/7.0;
        }
    }
    @Override
    public void 占用设备(double 所需产能) {
        this.占用+=所需产能;
    }

    @Override
    public void 占用设备(String 占用源) {
        this.资源占用图纸表.add(占用源);
    }


    public 设备(Constant.设备产能 _设备产能){
        this.设备编号= _设备产能.设备编号;
        this.设备名称= _设备产能.设备名称;
        this.白班设备产能= _设备产能.白班设备产能;
        this.二班设备产能= _设备产能.二班设备产能;
        this.资源占用图纸表=new ArrayList<>();
    }
}
